#[doc = "Register `CFG9` reader"]
pub struct R(crate::R<CFG9_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<CFG9_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<CFG9_SPEC>> for R {
    fn from(reader: crate::R<CFG9_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `CFG9` writer"]
pub struct W(crate::W<CFG9_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<CFG9_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<CFG9_SPEC>> for W {
    fn from(writer: crate::W<CFG9_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `AMASK` reader - Datapath ALU Mask. The mask value in this register is applied to the output of the Datapath ALU result before the result is stored. The AMASK_EN bit (CFG12) must be set for the mask to be operational."]
pub struct AMASK_R(crate::FieldReader<u8, u8>);
impl AMASK_R {
    pub(crate) fn new(bits: u8) -> Self {
        AMASK_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for AMASK_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `AMASK` writer - Datapath ALU Mask. The mask value in this register is applied to the output of the Datapath ALU result before the result is stored. The AMASK_EN bit (CFG12) must be set for the mask to be operational."]
pub struct AMASK_W<'a> {
    w: &'a mut W,
}
impl<'a> AMASK_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xff) | (value as u8 & 0xff);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:7 - Datapath ALU Mask. The mask value in this register is applied to the output of the Datapath ALU result before the result is stored. The AMASK_EN bit (CFG12) must be set for the mask to be operational."]
    #[inline(always)]
    pub fn amask(&self) -> AMASK_R {
        AMASK_R::new((self.bits & 0xff) as u8)
    }
}
impl W {
    #[doc = "Bits 0:7 - Datapath ALU Mask. The mask value in this register is applied to the output of the Datapath ALU result before the result is stored. The AMASK_EN bit (CFG12) must be set for the mask to be operational."]
    #[inline(always)]
    pub fn amask(&mut self) -> AMASK_W {
        AMASK_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Datapath ALU Mask\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cfg9](index.html) module"]
pub struct CFG9_SPEC;
impl crate::RegisterSpec for CFG9_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [cfg9::R](R) reader structure"]
impl crate::Readable for CFG9_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [cfg9::W](W) writer structure"]
impl crate::Writable for CFG9_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets CFG9 to value 0"]
impl crate::Resettable for CFG9_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
